<?php
namespace nur\sery\tools;

use nur\sery\output\msg;
use nur\sery\wip\app\app2;
use nur\sery\wip\app\cli\Application;

class SteamTrainApp extends Application {
  const PROJDIR = __DIR__.'/../..';
  const TITLE = "Train à vapeur";
  const USE_LOGFILE = true;
  const USE_RUNFILE = true;
  const USE_RUNLOCK = true;

  const ARGS = [
    "purpose" => self::TITLE,
    "description" => <<<EOT
Cette application peut être utilisée pour tester le lancement des tâches de fond
EOT,

    ["-c", "--count", "args" => 1,
      "help" => "spécifier le nombre d'étapes",
    ],
    ["-n", "--no-install-signal-handler", "value" => false,
      "help" => "ne pas installer le gestionnaire de signaux",
    ],
  ];

  protected $count = 100;

  protected bool $installSignalHandler = true;

  function main() {
    if ($this->installSignalHandler) app2::install_signal_handler();
    $count = intval($this->count);
    app2::action("Running train...", $count);
    for ($i = 1; $i <= $count; $i++) {
      msg::print("Tchou-tchou! x $i");
      app2::step();
      sleep(1);
    }
  }
}
